-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Select Box - Customize Drop-Down Button
Use the dropDownButtonTemplate to customize the drop-down button.
This demo illustrates three customization cases:
-
Custom image
Declare animgelement in the template. -
Load indicator
Declare the load indicator and a regular icon in the template. Display the load indicator while hiding the icon, and vice versa. -
Icon that depends on the selected value
Declare the default and the selected item's icon in the template. If there is a selected item, display its icon; otherwise, show the default icon.
Backend API
$(() => {
$('#custom-icon').dxSelectBox({
items: simpleProducts,
inputAttr: { 'aria-label': 'Simple Product' },
dropDownButtonTemplate() {
return $('<img>', {
alt: 'Custom icon',
src: '../../../../images/icons/custom-dropbutton-icon.svg',
class: 'custom-icon',
});
},
});
const $loadIndicator = $('<div>').dxLoadIndicator({ visible: false });
const $dropDownButtonImage = $('<img>', {
alt: 'Custom icon',
src: '../../../../images/icons/custom-dropbutton-icon.svg',
class: 'custom-icon',
});
$('#load-indicator').dxSelectBox({
inputAttr: { 'aria-label': 'Load Indicator' },
dropDownButtonTemplate(data, element) {
$(element).append($loadIndicator, $dropDownButtonImage);
},
dataSource: {
loadMode: 'raw',
load() {
const loadIndicator = $loadIndicator.dxLoadIndicator('instance');
const d = $.Deferred();
$dropDownButtonImage.hide();
loadIndicator.option('visible', true);
setTimeout(() => {
d.resolve(simpleProducts);
$dropDownButtonImage.show();
loadIndicator.option('visible', false);
}, 3000);
return d.promise();
},
},
});
const dropDownButtonTemplate = function (selectedItem) {
if (selectedItem) {
return () => $('<img>', {
alt: 'Custom icon',
src: `../../../../images/icons/${selectedItem.IconSrc}`,
class: 'custom-icon',
});
}
return 'dropDownButton';
};
$('#dynamic-template').dxSelectBox({
items: products,
displayExpr: 'Name',
inputAttr: { 'aria-label': 'Product' },
showClearButton: true,
valueExpr: 'ID',
value: 1,
itemTemplate(data) {
return `<div class='custom-item'><img alt='${data.Name}' src='../../../../images/icons/${
data.IconSrc}' /><div class='product-name'>${
data.Name}</div></div>`;
},
onSelectionChanged(e) {
e.component.option('dropDownButtonTemplate', dropDownButtonTemplate(e.selectedItem));
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Image as the icon</div>
<div class="dx-field-value">
<div id="custom-icon"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Load indicator as the icon</div>
<div class="dx-field-value">
<div id="load-indicator"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Value-dependent icon</div>
<div class="dx-field-value">
<div id="dynamic-template"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.dx-dropdowneditor-button .dx-button-content {
text-align: center;
}
.dx-dropdowneditor-button .dx-button-content .dx-loadindicator {
width: 1.5em;
height: 1.5em;
}
.custom-icon {
max-height: 100%;
max-width: 100%;
font-size: 28px;
display: inline-block;
vertical-align: middle;
}
.custom-item img {
float: right;
}
.custom-item .product-name {
line-height: 32px;
padding-left: 5px;
}
const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
];
const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}];

Backend API
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Image as the icon</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="simpleProducts"
[inputAttr]="{ 'aria-label': 'Simple Product' }"
>
<div *dxTemplate="let data of 'dropDownButton'">
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
class="custom-icon"
/>
</div>
</dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Load indicator as the icon</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="deferredProducts"
[inputAttr]="{ 'aria-label': 'Deferred Product' }"
>
<div *dxTemplate="let data of 'dropDownButton'">
<dx-load-indicator [visible]="!isLoaded"></dx-load-indicator>
<span [hidden]="!isLoaded">
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
class="custom-icon"
/>
</span>
</div>
</dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Value-dependent icon</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="products"
[inputAttr]="{ 'aria-label': 'Templated Product' }"
[(selectedItem)]="selectedItem"
[value]="1"
showClearButton="true"
displayExpr="Name"
valueExpr="ID"
>
<div *dxTemplate="let data of 'dropDownButton'">
@if (selectedItem) {
<img
alt="Custom icon"
src="../../../../images/icons/{{ selectedItem.IconSrc }}"
class="custom-icon"
/>
<div class="dx-dropdowneditor-icon"></div>
}
</div>
<div *dxTemplate="let data of 'item'" class="custom-item">
<img
alt="{{ data.Name }}"
src="../../../../images/icons/{{ data.IconSrc }}"
/>
<div class="product-name">{{ data.Name }}</div>
</div>
</dx-select-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxSelectBoxModule,
DxLoadIndicatorModule,
} from 'devextreme-angular';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSelectBoxModule,
DxLoadIndicatorModule,
],
})
export class AppComponent {
simpleProducts: string[];
products: Product[];
isLoaded = true;
selectedItem: Product;
deferredProducts = {
loadMode: 'raw',
load: () => {
this.isLoaded = false;
const promise = new Promise((resolve) => {
setTimeout(() => {
resolve(this.simpleProducts);
this.isLoaded = true;
}, 3000);
});
return promise;
},
};
constructor(service: Service) {
this.products = service.getProducts();
this.selectedItem = this.products[0];
this.simpleProducts = service.getSimpleProducts();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-dropdowneditor-button .dx-button-content {
text-align: center;
}
::ng-deep .dx-dropdowneditor-button .dx-button-content .dx-loadindicator {
width: 1.5em;
height: 1.5em;
}
::ng-deep .custom-icon {
max-height: 100%;
max-width: 100%;
font-size: 28px;
display: inline-block;
vertical-align: middle;
}
::ng-deep .custom-item img {
float: right;
}
::ng-deep .custom-item .product-name {
line-height: 32px;
padding-left: 5px;
}
import { Injectable } from '@angular/core';
export class Product {
ID: number;
Name: string;
Price: number;
Current_Inventory: number;
Backorder: number;
Manufacturing: number;
Category: string;
IconSrc: string;
}
const simpleProducts: string[] = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
];
const products: Product[] = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}];
@Injectable()
export class Service {
getSimpleProducts(): string[] {
return simpleProducts;
}
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
<template>
<div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Image as the icon</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
drop-down-button-template="imageIcon"
>
<template #imageIcon="{}">
<img
alt="Custom icon"
:src="'../../../../images/icons/custom-dropbutton-icon.svg'"
class="custom-icon"
>
</template>
</DxSelectBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Load indicator as the icon</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="deferredProducts"
:input-attr="{ 'aria-label': 'Deferred Product' }"
drop-down-button-template="loadIcon"
>
<template #loadIcon="{}">
<div>
<DxLoadIndicator :visible="!isLoaded"/>
<span :hidden="!isLoaded">
<img
alt="Custom icon"
:src="'../../../../images/icons/custom-dropbutton-icon.svg'"
class="custom-icon"
>
</span>
</div>
</template>
</DxSelectBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Value-dependent icon</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="products"
v-model:selected-item="selectedItem"
:input-attr="{ 'aria-label': 'Product' }"
:value="1"
:show-clear-button="true"
display-expr="Name"
value-expr="ID"
drop-down-button-template="valueIcon"
item-template="customItem"
>
<template #valueIcon="{}">
<div>
<img
v-if="selectedItem"
alt="Custom icon"
:src="'../../../../images/icons/' + selectedItem.IconSrc"
class="custom-icon"
>
<div
v-if="!selectedItem"
class="dx-dropdowneditor-icon"
/>
</div>
</template>
<template #customItem="{ data: itemData }">
<div class="custom-item">
<img
:alt="itemData.Name"
:src="'../../../../images/icons/' + itemData.IconSrc"
>
<div class="product-name">
{{ itemData.Name }}
</div>
</div>
</template>
</DxSelectBox>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { DxLoadIndicator } from 'devextreme-vue/load-indicator';
import { products, simpleProducts } from './data.ts';
const isLoaded = ref(true);
const selectedItem = ref(products[0]);
const deferredProducts = {
loadMode: 'raw',
load: () => {
isLoaded.value = false;
const promise = new Promise((resolve) => {
setTimeout(() => {
resolve(simpleProducts);
isLoaded.value = true;
}, 3000);
});
return promise;
},
};
</script>
<style scoped>
.dx-dropdowneditor-button .dx-button-content {
text-align: center;
}
.dx-dropdowneditor-button .dx-button-content .dx-loadindicator {
width: 1.5em;
height: 1.5em;
}
.custom-icon {
max-height: 100%;
max-width: 100%;
font-size: 28px;
display: inline-block;
vertical-align: middle;
}
.custom-item img {
float: right;
}
.custom-item .product-name {
line-height: 32px;
padding-left: 5px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
];
export const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
import React, { useCallback, useMemo, useState } from 'react';
import SelectBox from 'devextreme-react/select-box';
import { Template } from 'devextreme-react/core/template';
import {
products,
simpleProducts,
simpleProductLabel,
deferredProductLabel,
productLabel,
} from './data.ts';
import ImageIcon from './imageIcon.tsx';
import IndicatorIcon from './indicatorIcon.tsx';
import ConditionalIcon from './conditionalIcon.tsx';
import Item from './item.tsx';
function App() {
const [selectedItem, setSelectedItem] = useState(products[0]);
const [isLoaded, setIsLoaded] = useState(true);
const deferredProducts = useMemo<any>(
() => ({
loadMode: 'raw',
load: () => {
setIsLoaded(false);
const promise = new Promise((resolve) => {
setTimeout(() => {
resolve(simpleProducts);
setIsLoaded(true);
}, 3000);
});
return promise;
},
}),
[setIsLoaded],
);
const renderLoadIndicator = useCallback(
() => <IndicatorIcon isLoaded={isLoaded} />,
[isLoaded],
);
const renderConditionalIcon = useCallback(
() => <ConditionalIcon value={selectedItem} />,
[selectedItem],
);
const selectionChanged = useCallback((event: { selectedItem: any }) => {
setSelectedItem(event.selectedItem);
}, []);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Image as the icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={simpleProducts}
inputAttr={simpleProductLabel}
dropDownButtonRender={ImageIcon}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Load indicator as the icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={deferredProducts}
inputAttr={deferredProductLabel}
dropDownButtonTemplate="loadIndicator"
>
<Template
name="loadIndicator"
render={renderLoadIndicator}
/>
</SelectBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Value-dependent icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={products}
defaultValue={products[0].ID}
selectedItem={selectedItem}
displayExpr="Name"
inputAttr={productLabel}
showClearButton={true}
valueExpr="ID"
itemRender={Item}
dropDownButtonTemplate="conditionalIcon"
onSelectionChanged={selectionChanged}
>
<Template
name="conditionalIcon"
render={renderConditionalIcon}
/>
</SelectBox>
</div>
</div>
</div>
);
}
export default App;
import React, { useCallback, useMemo, useState } from 'react';
import SelectBox from 'devextreme-react/select-box';
import { Template } from 'devextreme-react/core/template';
import {
products,
simpleProducts,
simpleProductLabel,
deferredProductLabel,
productLabel,
} from './data.js';
import ImageIcon from './imageIcon.js';
import IndicatorIcon from './indicatorIcon.js';
import ConditionalIcon from './conditionalIcon.js';
import Item from './item.js';
function App() {
const [selectedItem, setSelectedItem] = useState(products[0]);
const [isLoaded, setIsLoaded] = useState(true);
const deferredProducts = useMemo(
() => ({
loadMode: 'raw',
load: () => {
setIsLoaded(false);
const promise = new Promise((resolve) => {
setTimeout(() => {
resolve(simpleProducts);
setIsLoaded(true);
}, 3000);
});
return promise;
},
}),
[setIsLoaded],
);
const renderLoadIndicator = useCallback(() => <IndicatorIcon isLoaded={isLoaded} />, [isLoaded]);
const renderConditionalIcon = useCallback(
() => <ConditionalIcon value={selectedItem} />,
[selectedItem],
);
const selectionChanged = useCallback((event) => {
setSelectedItem(event.selectedItem);
}, []);
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Image as the icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={simpleProducts}
inputAttr={simpleProductLabel}
dropDownButtonRender={ImageIcon}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Load indicator as the icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={deferredProducts}
inputAttr={deferredProductLabel}
dropDownButtonTemplate="loadIndicator"
>
<Template
name="loadIndicator"
render={renderLoadIndicator}
/>
</SelectBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Value-dependent icon</div>
<div className="dx-field-value">
<SelectBox
dataSource={products}
defaultValue={products[0].ID}
selectedItem={selectedItem}
displayExpr="Name"
inputAttr={productLabel}
showClearButton={true}
valueExpr="ID"
itemRender={Item}
dropDownButtonTemplate="conditionalIcon"
onSelectionChanged={selectionChanged}
>
<Template
name="conditionalIcon"
render={renderConditionalIcon}
/>
</SelectBox>
</div>
</div>
</div>
);
}
export default App;
import React from 'react';
interface ConditionalIconProps {
value: any;
}
export default function ConditionalIcon({ value }: ConditionalIconProps) {
if (value) {
return (
<img
alt="Custom icon"
src={`../../../../images/icons/${value.IconSrc}`}
className="custom-icon"
/>
);
}
return <div className="dx-dropdowneditor-icon"></div>;
}
import React from 'react';
export default function ImageIcon() {
return (
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
className="custom-icon"
/>
);
}
import React from 'react';
import LoadIndicator from 'devextreme-react/load-indicator';
interface IndicatorIconProps {
isLoaded: any;
}
export default function IndicatorIcon({ isLoaded }: IndicatorIconProps) {
return (
<span>
<LoadIndicator visible={!isLoaded} />
<span hidden={!isLoaded}>
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
className="custom-icon"
/>
</span>
</span>
);
}
import React from 'react';
interface ItemProps {
IconSrc: string;
Name: string;
}
export default function Item({ IconSrc, Name }: ItemProps) {
return (
<div className="custom-item">
<img
alt={Name}
src={`../../../../images/icons/${IconSrc}`}
/>
<div className="product-name">{Name}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
export const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
];
export const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
IconSrc: 'video-player.svg',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
IconSrc: 'tv.svg',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
}];
export const simpleProductLabel = { 'aria-label': 'Simple Product' };
export const deferredProductLabel = { 'aria-label': 'Deferred Product' };
export const productLabel = { 'aria-label': 'Product' };
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
export default function ConditionalIcon({ value }) {
if (value) {
return (
<img
alt="Custom icon"
src={`../../../../images/icons/${value.IconSrc}`}
className="custom-icon"
/>
);
}
return <div className="dx-dropdowneditor-icon"></div>;
}
import React from 'react';
export default function ImageIcon() {
return (
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
className="custom-icon"
/>
);
}
import React from 'react';
import LoadIndicator from 'devextreme-react/load-indicator';
export default function IndicatorIcon({ isLoaded }) {
return (
<span>
<LoadIndicator visible={!isLoaded} />
<span hidden={!isLoaded}>
<img
alt="Custom icon"
src="../../../../images/icons/custom-dropbutton-icon.svg"
className="custom-icon"
/>
</span>
</span>
);
}
import React from 'react';
export default function Item({ IconSrc, Name }) {
return (
<div className="custom-item">
<img
alt={Name}
src={`../../../../images/icons/${IconSrc}`}
/>
<div className="product-name">{Name}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
];
export const products = [
{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
IconSrc: 'video-player.svg',
},
{
ID: 2,
Name: 'SuperHD Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
IconSrc: 'video-player.svg',
},
{
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
},
{
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
IconSrc: 'tv.svg',
},
{
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
IconSrc: 'tv.svg',
},
];
export const simpleProductLabel = { 'aria-label': 'Simple Product' };
export const deferredProductLabel = { 'aria-label': 'Deferred Product' };
export const productLabel = { 'aria-label': 'Product' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-dropdowneditor-button .dx-button-content {
text-align: center;
}
.dx-dropdowneditor-button .dx-button-content .dx-loadindicator {
width: 1.5em;
height: 1.5em;
}
.custom-icon {
max-height: 100%;
max-width: 100%;
font-size: 28px;
display: inline-block;
vertical-align: middle;
}
.custom-item img {
float: right;
}
.custom-item .product-name {
line-height: 32px;
padding-left: 5px;
}